package de.thpeetz.kontor.comics.views;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.vaadin.flow.component.ComponentEvent;
import com.vaadin.flow.component.ComponentEventListener;
import com.vaadin.flow.component.Key;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.button.ButtonVariant;
import com.vaadin.flow.component.formlayout.FormLayout;
import com.vaadin.flow.component.grid.Grid;
import com.vaadin.flow.component.orderedlayout.HorizontalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.data.binder.BeanValidationBinder;
import com.vaadin.flow.data.binder.Binder;

import de.thpeetz.kontor.comics.data.ComicWork;
import de.thpeetz.kontor.comics.data.Worktype;

public class WorktypeForm extends FormLayout {

    private static final Logger log = LoggerFactory.getLogger(WorktypeForm.class);

    TextField name = new TextField("Name");
    Grid<ComicWork> comicWorks = new Grid<>(ComicWork.class);

    Button save = new Button("Save");
    Button delete = new Button("Delete");
    Button close = new Button("Cancel");

    Binder<Worktype> binder = new BeanValidationBinder<>(Worktype.class);

    public WorktypeForm() {
        addClassName("worktype-form");
        binder.bindInstanceFields(this);

        comicWorks.setColumns("comic.title", "artist.name");
        comicWorks.getColumnByKey("comic.title").setHeader("Comic");
        comicWorks.getColumnByKey("artist.name").setHeader("Artist");
        comicWorks.getColumns().forEach(col -> col.setAutoWidth(true));

        add(name, comicWorks, createButtonsLayout());
    }

    private HorizontalLayout createButtonsLayout() {
        save.addThemeVariants(ButtonVariant.LUMO_PRIMARY);
        delete.addThemeVariants(ButtonVariant.LUMO_ERROR);
        close.addThemeVariants(ButtonVariant.LUMO_TERTIARY);

        save.addClickShortcut(Key.ENTER);
        close.addClickShortcut(Key.ESCAPE);

        save.addClickListener(event -> validateAndSave());
        delete.addClickListener(event -> fireEvent(new DeleteEvent(this, binder.getBean())));
        close.addClickListener(event -> fireEvent(new CloseEvent(this)));

        binder.addStatusChangeListener(e -> save.setEnabled(binder.isValid()));
        return new HorizontalLayout(save, delete, close);
    }

    private void validateAndSave() {
        if (binder.isValid()) {
            fireEvent(new SaveEvent(this, binder.getBean()));
        }
    }

    public void setWorktype(Worktype worktype) {
        binder.setBean(worktype);
    }

    public void setComicWorks(List<ComicWork> works) {
        log.info("Setting comic works: {}", works);
        this.comicWorks.setItems(works);
    }

    public abstract static class WorktypeFormEvent extends ComponentEvent<WorktypeForm> {
        private Worktype worktype;

        protected WorktypeFormEvent(WorktypeForm source, Worktype worktype) {
            super(source, false);
            this.worktype = worktype;
        }

        public Worktype getWorktype() {
            return worktype;
        }
    }

    public static class SaveEvent extends WorktypeFormEvent {
        SaveEvent(WorktypeForm source, Worktype worktype) {
            super(source, worktype);
        }
    }

    public static class DeleteEvent extends WorktypeFormEvent {
        DeleteEvent(WorktypeForm source, Worktype worktype) {
            super(source, worktype);
        }
    }

    public static class CloseEvent extends WorktypeFormEvent {
        CloseEvent(WorktypeForm source) {
            super(source, null);
        }
    }

    public void addDeleteListener(ComponentEventListener<DeleteEvent> listener) {
        addListener(DeleteEvent.class, listener);
    }

    public void addSaveListener(ComponentEventListener<SaveEvent> listener) {
        addListener(SaveEvent.class, listener);
    }

    public void addCloseListener(ComponentEventListener<CloseEvent> listener) {
        addListener(CloseEvent.class, listener);
    }
}
